Index: scintilla/include/SciLexer.h
===================================================================
--- scintilla/include/SciLexer.h	(revisão 5267)
+++ scintilla/include/SciLexer.h	(cópia de trabalho)
@@ -519,16 +519,19 @@
 #define SCE_BAAN_WORD2 10
 #define SCE_LISP_DEFAULT 0
 #define SCE_LISP_COMMENT 1
-#define SCE_LISP_NUMBER 2
-#define SCE_LISP_KEYWORD 3
-#define SCE_LISP_KEYWORD_KW 4
-#define SCE_LISP_SYMBOL 5
-#define SCE_LISP_STRING 6
-#define SCE_LISP_STRINGEOL 8
-#define SCE_LISP_IDENTIFIER 9
-#define SCE_LISP_OPERATOR 10
-#define SCE_LISP_SPECIAL 11
-#define SCE_LISP_MULTI_COMMENT 12
+#define SCE_LISP_MULTI_COMMENT 2
+#define SCE_LISP_NUMBER 3
+#define SCE_LISP_KEYWORD 4
+#define SCE_LISP_SPECIAL_KEYWORD 5
+#define SCE_LISP_SYMBOL 6
+#define SCE_LISP_CHARACTER 7
+#define SCE_LISP_STRING 8
+#define SCE_LISP_STRINGEOL 9
+#define SCE_LISP_IDENTIFIER 10
+#define SCE_LISP_OPERATOR 11
+#define SCE_LISP_SPECIAL 12
+#define SCE_LISP_MACRO 13
+#define SCE_LISP_MACRO_DISPATCH 14
 #define SCE_EIFFEL_DEFAULT 0
 #define SCE_EIFFEL_COMMENTLINE 1
 #define SCE_EIFFEL_NUMBER 2
Index: scintilla/KeyWords.cxx
===================================================================
--- scintilla/KeyWords.cxx	(revisão 5267)
+++ scintilla/KeyWords.cxx	(cópia de trabalho)
@@ -337,6 +337,7 @@
 	LINK_LEXER(lmCss);
 	LINK_LEXER(lmD);
 	LINK_LEXER(lmDiff);
+	LINK_LEXER(lmLisp);
 	LINK_LEXER(lmF77);
 	LINK_LEXER(lmForth);
 	LINK_LEXER(lmFortran);
Index: scintilla/Makefile.am
===================================================================
--- scintilla/Makefile.am	(revisão 5267)
+++ scintilla/Makefile.am	(cópia de trabalho)
@@ -19,6 +19,7 @@
 LexFortran.cxx \
 LexHaskell.cxx \
 LexHTML.cxx \
+LexLisp.cxx \
 LexLua.cxx \
 LexMarkdown.cxx \
 LexMatlab.cxx \
Index: src/highlighting.c
===================================================================
--- src/highlighting.c	(revisão 5267)
+++ src/highlighting.c	(cópia de trabalho)
@@ -1075,7 +1075,58 @@
 	set_sci_style(sci, SCE_DIFF_CHANGED, ft_id, 7);
 }
 
+static void styleset_lisp_init(gint ft_id, GKeyFile *config, GKeyFile *config_home)
+{
+	new_styleset(ft_id, 15);
+	get_keyfile_style(config, config_home, "default", &style_sets[ft_id].styling[0]);
+	get_keyfile_style(config, config_home, "comment", &style_sets[ft_id].styling[1]);
+	get_keyfile_style(config, config_home, "multicomment", &style_sets[ft_id].styling[2]);
+	get_keyfile_style(config, config_home, "number", &style_sets[ft_id].styling[3]);
+	get_keyfile_style(config, config_home, "keyword", &style_sets[ft_id].styling[4]);
+	get_keyfile_style(config, config_home, "special_keyword", &style_sets[ft_id].styling[5]);
+	get_keyfile_style(config, config_home, "symbol", &style_sets[ft_id].styling[6]);
+	get_keyfile_style(config, config_home, "string", &style_sets[ft_id].styling[7]);
+	get_keyfile_style(config, config_home, "stringeol", &style_sets[ft_id].styling[8]);
+	get_keyfile_style(config, config_home, "identifier", &style_sets[ft_id].styling[9]);
+	get_keyfile_style(config, config_home, "operator", &style_sets[ft_id].styling[10]);
+	get_keyfile_style(config, config_home, "special", &style_sets[ft_id].styling[11]);
+	get_keyfile_style(config, config_home, "character", &style_sets[ft_id].styling[12]);
+	get_keyfile_style(config, config_home, "macro", &style_sets[ft_id].styling[13]);
+	get_keyfile_style(config, config_home, "macrodispatch", &style_sets[ft_id].styling[14]);
+	
+	style_sets[ft_id].keywords = g_new(gchar*, 3);
+	get_keyfile_keywords(config, config_home, "keywords", ft_id, 0);
+	get_keyfile_keywords(config, config_home, "special_keywords", ft_id, 1);
+	style_sets[ft_id].keywords[2] = NULL;
+}
 
+
+static void styleset_lisp(ScintillaObject *sci, gint ft_id)
+{
+	apply_filetype_properties(sci, SCLEX_LISP, ft_id);
+
+	sci_set_keywords(sci, 0, style_sets[ft_id].keywords[0]);
+	sci_set_keywords(sci, 1, style_sets[ft_id].keywords[1]);
+
+	set_sci_style(sci, STYLE_DEFAULT, ft_id, 0);	
+	set_sci_style(sci, SCE_LISP_DEFAULT, ft_id, 0);
+	set_sci_style(sci, SCE_LISP_COMMENT, ft_id, 1);
+	set_sci_style(sci, SCE_LISP_MULTI_COMMENT, ft_id, 2);
+	set_sci_style(sci, SCE_LISP_NUMBER, ft_id, 3);
+	set_sci_style(sci, SCE_LISP_KEYWORD, ft_id, 4);
+	set_sci_style(sci, SCE_LISP_SPECIAL_KEYWORD, ft_id, 5);
+	set_sci_style(sci, SCE_LISP_SYMBOL, ft_id, 6);
+	set_sci_style(sci, SCE_LISP_STRING, ft_id, 7);
+	set_sci_style(sci, SCE_LISP_STRINGEOL, ft_id, 8);
+	set_sci_style(sci, SCE_LISP_IDENTIFIER, ft_id, 9);
+	set_sci_style(sci, SCE_LISP_OPERATOR, ft_id, 10);
+	set_sci_style(sci, SCE_LISP_SPECIAL, ft_id, 11);
+	set_sci_style(sci, SCE_LISP_CHARACTER, ft_id, 12);
+	set_sci_style(sci, SCE_LISP_MACRO, ft_id, 13);
+	set_sci_style(sci, SCE_LISP_MACRO_DISPATCH, ft_id, 14);
+}
+
+
 static void styleset_latex_init(gint ft_id, GKeyFile *config, GKeyFile *config_home)
 {
 	new_styleset(ft_id, 5);
@@ -3276,6 +3327,7 @@
 		init_styleset_case(GEANY_FILETYPES_CSS,		styleset_css_init);
 		init_styleset_case(GEANY_FILETYPES_D,		styleset_d_init);
 		init_styleset_case(GEANY_FILETYPES_DIFF,	styleset_diff_init);
+		init_styleset_case(GEANY_FILETYPES_LISP,	styleset_lisp_init);
 		init_styleset_case(GEANY_FILETYPES_DOCBOOK,	styleset_docbook_init);
 		init_styleset_case(GEANY_FILETYPES_FERITE,	styleset_ferite_init);
 		init_styleset_case(GEANY_FILETYPES_F77,		styleset_f77_init);
@@ -3346,6 +3398,7 @@
 		styleset_case(GEANY_FILETYPES_CSS,		styleset_css);
 		styleset_case(GEANY_FILETYPES_D,		styleset_d);
 		styleset_case(GEANY_FILETYPES_DIFF,		styleset_diff);
+		styleset_case(GEANY_FILETYPES_LISP,		styleset_lisp);
 		styleset_case(GEANY_FILETYPES_DOCBOOK,	styleset_docbook);
 		styleset_case(GEANY_FILETYPES_FERITE,	styleset_ferite);
 		styleset_case(GEANY_FILETYPES_F77,		styleset_f77);
Index: src/filetypes.c
===================================================================
--- src/filetypes.c	(revisão 5267)
+++ src/filetypes.c	(cópia de trabalho)
@@ -506,6 +506,17 @@
 	ft->comment_close = NULL;
 	ft->group = GEANY_FILETYPE_GROUP_MISC;
 
+#define LISP
+	ft = filetypes[GEANY_FILETYPES_LISP];
+	ft->lang = -2;
+	ft->name = g_strdup("Lisp");
+	filetype_make_title(ft, TITLE_FILE);
+	ft->extension = g_strdup("lisp");
+	ft->pattern = utils_strv_new("*.lisp", NULL);
+	ft->comment_open = g_strdup(";");
+	ft->comment_close = NULL;
+	ft->group = GEANY_FILETYPE_GROUP_SCRIPT;
+
 #define CONF
 	ft = filetypes[GEANY_FILETYPES_CONF];
 	ft->lang = 10;
Index: src/filetypes.h
===================================================================
--- src/filetypes.h	(revisão 5267)
+++ src/filetypes.h	(cópia de trabalho)
@@ -59,6 +59,7 @@
 	GEANY_FILETYPES_AS,
 	GEANY_FILETYPES_R,
 	GEANY_FILETYPES_DIFF,
+	GEANY_FILETYPES_LISP,
 	GEANY_FILETYPES_HTML,
 	GEANY_FILETYPES_PYTHON,
 	GEANY_FILETYPES_CS,
Index: data/filetype_extensions.conf
===================================================================
--- data/filetype_extensions.conf	(revisão 5267)
+++ data/filetype_extensions.conf	(cópia de trabalho)
@@ -43,6 +43,7 @@
 CMake=CMakeLists.txt;*.cmake;*.ctest;
 Conf=*.conf;*.ini;config;*rc;*.cfg;*.desktop;
 Diff=*.diff;*.patch;*.rej;
+Lisp=*.lisp;
 NSIS=*.nsi;*.nsh;
 Po=*.po;*.pot;
 LaTeX=*.tex;*.sty;*.idx;*.ltx;
Index: wscript
===================================================================
--- wscript	(revisão 5267)
+++ wscript	(cópia de trabalho)
@@ -88,7 +88,7 @@
 	'scintilla/LexAda.cxx', 'scintilla/LexAsm.cxx', 'scintilla/LexBash.cxx',
 	'scintilla/LexBasic.cxx', 'scintilla/LexCaml.cxx', 'scintilla/LexCmake.cxx', 'scintilla/LexCPP.cxx',
 	'scintilla/LexCSS.cxx', 'scintilla/LexD.cxx', 'scintilla/LexForth.cxx',
-	'scintilla/LexFortran.cxx', 'scintilla/LexHaskell.cxx', 'scintilla/LexHTML.cxx',
+	'scintilla/LexFortran.cxx', 'scintilla/LexHaskell.cxx', 'scintilla/LexHTML.cxx', 'scintilla/LexLisp.cxx'
 	'scintilla/LexLua.cxx', 'scintilla/LexMarkdown.cxx', 'scintilla/LexMatlab.cxx',
 	'scintilla/LexNsis.cxx', 'scintilla/LexOthers.cxx',
 	'scintilla/LexPascal.cxx', 'scintilla/LexPerl.cxx', 'scintilla/LexPython.cxx',