>From 285d8d6db0303bf62b7bf4918ad3db433f7b872a Mon Sep 17 00:00:00 2001
From: Quentin Glidic <sardemff7+git@sardemff7.net>
Date: Sat, 19 May 2012 14:15:36 +0200
Subject: [PATCH 6/9] Autotools: Remove EXTRA_LTLIBRARIES

---
 addons/src/Makefile.am                 |    2 --
 codenav/src/Makefile.am                |    2 --
 debugger/src/Makefile.am               |    2 --
 devhelp/src/Makefile.am                |    2 --
 geanydoc/src/Makefile.am               |    2 --
 geanyextrasel/src/Makefile.am          |    2 --
 geanygdb/src/Makefile.am               |    3 ---
 geanygendoc/src/Makefile.am            |    2 --
 geanyinsertnum/src/Makefile.am         |    2 --
 geanylatex/src/Makefile.am             |    2 --
 geanylipsum/src/Makefile.am            |    2 --
 geanylua/Makefile.am                   |    2 --
 geanymacro/src/Makefile.am             |    2 --
 geanyminiscript/src/Makefile.am        |    2 --
 geanynumberedbookmarks/src/Makefile.am |    2 --
 geanypg/src/Makefile.am                |    2 --
 geanyprj/src/Makefile.am               |    3 +--
 geanysendmail/src/Makefile.am          |    2 --
 geanyvc/src/Makefile.am                |    2 --
 geniuspaste/src/Makefile.am            |    2 --
 gproject/src/Makefile.am               |    3 +--
 multiterm/src/Makefile.am              |    2 --
 pretty-printer/src/Makefile.am         |    2 --
 shiftcolumn/src/Makefile.am            |    2 --
 spellcheck/src/Makefile.am             |    2 --
 tableconvert/src/Makefile.am           |    2 --
 treebrowser/src/Makefile.am            |    2 --
 updatechecker/src/Makefile.am          |    2 --
 webhelper/src/Makefile.am              |    2 --
 xmlsnippets/src/Makefile.am            |    2 --
 30 files changed, 2 insertions(+), 61 deletions(-)

diff --git a/addons/src/Makefile.am b/addons/src/Makefile.am
index eabb6e8..6b7c278 100644
--- a/addons/src/Makefile.am
+++ b/addons/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_ADDONS
 geanyplugins_LTLIBRARIES = addons.la
-else
-EXTRA_LTLIBRARIES = addons.la
 endif
 
 addons_la_SOURCES = \
diff --git a/codenav/src/Makefile.am b/codenav/src/Makefile.am
index 0fff63e..98c7c1c 100644
--- a/codenav/src/Makefile.am
+++ b/codenav/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_CODENAV
 geanyplugins_LTLIBRARIES = codenav.la
-else
-EXTRA_LTLIBRARIES = codenav.la
 endif
 
 codenav_la_SOURCES = \
diff --git a/debugger/src/Makefile.am b/debugger/src/Makefile.am
index 953f34a..7f4757b 100644
--- a/debugger/src/Makefile.am
+++ b/debugger/src/Makefile.am
@@ -3,8 +3,6 @@ include $(top_srcdir)/build/vars.docs.mk
 
 if ENABLE_DEBUGGER
 geanyplugins_LTLIBRARIES = debugger.la
-else
-EXTRA_LTLIBRARIES = debugger.la
 endif
 
 plugin = debugger
diff --git a/devhelp/src/Makefile.am b/devhelp/src/Makefile.am
index cf782d7..870462c 100644
--- a/devhelp/src/Makefile.am
+++ b/devhelp/src/Makefile.am
@@ -4,8 +4,6 @@ plugin = devhelp
 
 if ENABLE_DEVHELP
 geanyplugins_LTLIBRARIES = devhelp.la
-else
-EXTRA_LTLIBRARIES = devhelp.la
 endif
 
 devhelp_la_SOURCES = \
diff --git a/geanydoc/src/Makefile.am b/geanydoc/src/Makefile.am
index 8f40db5..2e98e63 100644
--- a/geanydoc/src/Makefile.am
+++ b/geanydoc/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYDOC
 geanyplugins_LTLIBRARIES = geanydoc.la
-else
-EXTRA_LTLIBRARIES = geanydoc.la
 endif
 
 geanydoc_la_SOURCES = \
diff --git a/geanyextrasel/src/Makefile.am b/geanyextrasel/src/Makefile.am
index 0e42a6d..0931dcc 100644
--- a/geanyextrasel/src/Makefile.am
+++ b/geanyextrasel/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYEXTRASEL
 geanyplugins_LTLIBRARIES = geanyextrasel.la
-else
-EXTRA_LTLIBRARIES = geanyextrasel.la
 endif
 
 geanyextrasel_la_SOURCES = extrasel.c
diff --git a/geanygdb/src/Makefile.am b/geanygdb/src/Makefile.am
index fce4bb4..0f27137 100644
--- a/geanygdb/src/Makefile.am
+++ b/geanygdb/src/Makefile.am
@@ -4,9 +4,6 @@ if ENABLE_GEANYGDB
 geanygdbdir = $(libexecdir)/geany-plugins/geanygdb
 geanyplugins_LTLIBRARIES = geanygdb.la
 geanygdb_PROGRAMS = ttyhelper
-else
-EXTRA_LTLIBRARIES = geanygdb.la
-EXTRA_PROGRAMS = ttyhelper
 endif
 
 geanygdb_la_SOURCES = \
diff --git a/geanygendoc/src/Makefile.am b/geanygendoc/src/Makefile.am
index 035e922..45b33dd 100644
--- a/geanygendoc/src/Makefile.am
+++ b/geanygendoc/src/Makefile.am
@@ -3,8 +3,6 @@ plugin = geanygendoc
 
 if ENABLE_GEANYGENDOC
 geanyplugins_LTLIBRARIES = geanygendoc.la
-else
-EXTRA_LTLIBRARIES = geanygendoc.la
 endif
 
 geanygendoc_la_SOURCES = \
diff --git a/geanyinsertnum/src/Makefile.am b/geanyinsertnum/src/Makefile.am
index 5914fe0..3614f75 100644
--- a/geanyinsertnum/src/Makefile.am
+++ b/geanyinsertnum/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYINSERTNUM
 geanyplugins_LTLIBRARIES = geanyinsertnum.la
-else
-EXTRA_LTLIBRARIES = geanyinsertnum.la
 endif
 
 geanyinsertnum_la_SOURCES = insertnum.c
diff --git a/geanylatex/src/Makefile.am b/geanylatex/src/Makefile.am
index 0ce1d26..393de25 100644
--- a/geanylatex/src/Makefile.am
+++ b/geanylatex/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYLATEX
 geanyplugins_LTLIBRARIES = geanylatex.la
-else
-EXTRA_LTLIBRARIES = geanylatex.la
 endif
 
 geanylatex_la_SOURCES = \
diff --git a/geanylipsum/src/Makefile.am b/geanylipsum/src/Makefile.am
index 6bf9bbe..2146b3a 100644
--- a/geanylipsum/src/Makefile.am
+++ b/geanylipsum/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYLIPSUM
 geanyplugins_LTLIBRARIES = geanylipsum.la
-else
-EXTRA_LTLIBRARIES = geanylipsum.la
 endif
 
 geanylipsum_la_SOURCES = geanylipsum.c
diff --git a/geanylua/Makefile.am b/geanylua/Makefile.am
index a3782c8..9743236 100644
--- a/geanylua/Makefile.am
+++ b/geanylua/Makefile.am
@@ -14,8 +14,6 @@ if ENABLE_GEANYLUA
 geanyplugins_LTLIBRARIES = geanylua.la
 geanyluadir = $(pkglibdir)/geanylua
 geanylua_LTLIBRARIES = libgeanylua.la
-else
-EXTRA_LTLIBRARIES = geanylua.la libgeanylua.la
 endif
 
 geanylua_la_SOURCES = geanylua.c
diff --git a/geanymacro/src/Makefile.am b/geanymacro/src/Makefile.am
index 9933e36..b6120aa 100644
--- a/geanymacro/src/Makefile.am
+++ b/geanymacro/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYMACRO
 geanyplugins_LTLIBRARIES = geanymacro.la
-else
-EXTRA_LTLIBRARIES = geanymacro.la
 endif
 
 geanymacro_la_SOURCES = geanymacro.c
diff --git a/geanyminiscript/src/Makefile.am b/geanyminiscript/src/Makefile.am
index 5dc89c8..cd77a84 100644
--- a/geanyminiscript/src/Makefile.am
+++ b/geanyminiscript/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYMINISCRIPT
 geanyplugins_LTLIBRARIES = geanyminiscript.la
-else
-EXTRA_LTLIBRARIES = geanyminiscript.la
 endif
 
 geanyminiscript_la_SOURCES = gms.c gms.h gms_gui.c gms_gui.h gms_debug.h
diff --git a/geanynumberedbookmarks/src/Makefile.am b/geanynumberedbookmarks/src/Makefile.am
index a0677cf..47e05dc 100644
--- a/geanynumberedbookmarks/src/Makefile.am
+++ b/geanynumberedbookmarks/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYNUMBEREDBOOKMARKS
 geanyplugins_LTLIBRARIES = geanynumberedbookmarks.la
-else
-EXTRA_LTLIBRARIES = geanynumberedbookmarks.la
 endif
 
 geanynumberedbookmarks_la_SOURCES = geanynumberedbookmarks.c
diff --git a/geanypg/src/Makefile.am b/geanypg/src/Makefile.am
index 2bcd815..86e769e 100644
--- a/geanypg/src/Makefile.am
+++ b/geanypg/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYPG
 geanyplugins_LTLIBRARIES = geanypg.la
-else
-EXTRA_LTLIBRARIES = geanypg.la
 endif
 
 geanypg_la_SOURCES = \
diff --git a/geanyprj/src/Makefile.am b/geanyprj/src/Makefile.am
index aae5b45..8161a16 100644
--- a/geanyprj/src/Makefile.am
+++ b/geanyprj/src/Makefile.am
@@ -2,9 +2,8 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYPRJ
 geanyplugins_LTLIBRARIES = geanyprj.la
-else
-EXTRA_LTLIBRARIES = geanyprj.la
 endif
+
 geanyprj_la_SOURCES = geanyprj.c \
 	geanyprj.h \
 	menu.c \
diff --git a/geanysendmail/src/Makefile.am b/geanysendmail/src/Makefile.am
index f1f6256..b36f3da 100644
--- a/geanysendmail/src/Makefile.am
+++ b/geanysendmail/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYSENDMAIL
 geanyplugins_LTLIBRARIES = geanysendmail.la
-else
-EXTRA_LTLIBRARIES = geanysendmail.la
 endif
 
 geanysendmail_la_SOURCES = geanysendmail.c icon.h
diff --git a/geanyvc/src/Makefile.am b/geanyvc/src/Makefile.am
index 557ac14..0359255 100644
--- a/geanyvc/src/Makefile.am
+++ b/geanyvc/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GEANYVC
 geanyplugins_LTLIBRARIES = geanyvc.la
-else
-EXTRA_LTLIBRARIES = geanyvc.la
 endif
 
 geanyvc_la_SOURCES = \
diff --git a/geniuspaste/src/Makefile.am b/geniuspaste/src/Makefile.am
index 1701bbc..804b4d0 100644
--- a/geniuspaste/src/Makefile.am
+++ b/geniuspaste/src/Makefile.am
@@ -3,8 +3,6 @@ plugin = geniuspaste
 
 if ENABLE_GENIUSPASTE
 geanyplugins_LTLIBRARIES = geniuspaste.la
-else
-EXTRA_LTLIBRARIES = geniuspaste.la
 endif
 
 geniuspaste_la_SOURCES = geniuspaste.c
diff --git a/gproject/src/Makefile.am b/gproject/src/Makefile.am
index 926c7c7..1dea562 100644
--- a/gproject/src/Makefile.am
+++ b/gproject/src/Makefile.am
@@ -2,9 +2,8 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_GPROJECT
 geanyplugins_LTLIBRARIES = gproject.la
-else
-EXTRA_LTLIBRARIES = gproject.la
 endif
+
 gproject_la_SOURCES = \
 	gproject-main.c \
 	gproject-project.h \
diff --git a/multiterm/src/Makefile.am b/multiterm/src/Makefile.am
index 389e316..8fc7bd9 100644
--- a/multiterm/src/Makefile.am
+++ b/multiterm/src/Makefile.am
@@ -5,8 +5,6 @@ plugin = multiterm
 
 if ENABLE_MULTITERM
 geanyplugins_LTLIBRARIES = multiterm.la
-else
-EXTRA_LTLIBRARIES = multiterm.la
 endif
 
 multiterm_la_VALAFLAGS = \
diff --git a/pretty-printer/src/Makefile.am b/pretty-printer/src/Makefile.am
index 301f2c7..2642444 100644
--- a/pretty-printer/src/Makefile.am
+++ b/pretty-printer/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_PRETTY_PRINTER
 geanyplugins_LTLIBRARIES = pretty-printer.la
-else
-EXTRA_LTLIBRARIES = pretty-printer.la
 endif
 
 pretty_printer_la_SOURCES = \
diff --git a/shiftcolumn/src/Makefile.am b/shiftcolumn/src/Makefile.am
index d5a940c..94a87a8 100644
--- a/shiftcolumn/src/Makefile.am
+++ b/shiftcolumn/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_SHIFTCOLUMN
 geanyplugins_LTLIBRARIES = shiftcolumn.la
-else
-EXTRA_LTLIBRARIES = shiftcolumn.la
 endif
 
 shiftcolumn_la_SOURCES = shiftcolumn.c
diff --git a/spellcheck/src/Makefile.am b/spellcheck/src/Makefile.am
index cb63876..b6d5095 100644
--- a/spellcheck/src/Makefile.am
+++ b/spellcheck/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_SPELLCHECK
 geanyplugins_LTLIBRARIES = spellcheck.la
-else
-EXTRA_LTLIBRARIES = spellcheck.la
 endif
 
 spellcheck_la_SOURCES = \
diff --git a/tableconvert/src/Makefile.am b/tableconvert/src/Makefile.am
index 7f21055..862970f 100644
--- a/tableconvert/src/Makefile.am
+++ b/tableconvert/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_TABLECONVERT
 geanyplugins_LTLIBRARIES = tableconvert.la
-else
-EXTRA_LTLIBRARIES = tableconvert.la
 endif
 
 tableconvert_la_SOURCES = tableconvert.c
diff --git a/treebrowser/src/Makefile.am b/treebrowser/src/Makefile.am
index 0da00e3..5328b49 100644
--- a/treebrowser/src/Makefile.am
+++ b/treebrowser/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_TREEBROWSER
 geanyplugins_LTLIBRARIES = treebrowser.la
-else
-EXTRA_LTLIBRARIES = treebrowser.la
 endif
 
 treebrowser_la_SOURCES = treebrowser.c
diff --git a/updatechecker/src/Makefile.am b/updatechecker/src/Makefile.am
index 6d7e5c2..8fefa56 100644
--- a/updatechecker/src/Makefile.am
+++ b/updatechecker/src/Makefile.am
@@ -3,8 +3,6 @@ plugin = updatechecker
 
 if ENABLE_UPDATECHECKER
 geanyplugins_LTLIBRARIES = updatechecker.la
-else
-EXTRA_LTLIBRARIES = updatechecker.la
 endif
 
 updatechecker_la_SOURCES = updatechecker.c
diff --git a/webhelper/src/Makefile.am b/webhelper/src/Makefile.am
index 3521030..733788a 100644
--- a/webhelper/src/Makefile.am
+++ b/webhelper/src/Makefile.am
@@ -3,8 +3,6 @@ plugin = webhelper
 
 if ENABLE_WEBHELPER
 geanyplugins_LTLIBRARIES = webhelper.la
-else
-EXTRA_LTLIBRARIES = webhelper.la
 endif
 
 
diff --git a/xmlsnippets/src/Makefile.am b/xmlsnippets/src/Makefile.am
index 50ba596..bd8b2e1 100644
--- a/xmlsnippets/src/Makefile.am
+++ b/xmlsnippets/src/Makefile.am
@@ -2,8 +2,6 @@ include $(top_srcdir)/build/vars.build.mk
 
 if ENABLE_XMLSNIPPETS
 geanyplugins_LTLIBRARIES = xmlsnippets.la
-else
-EXTRA_LTLIBRARIES = xmlsnippets.la
 endif
 
 xmlsnippets_la_SOURCES = \
-- 
1.7.10.1