>From 6d5c1cb8d7591b676651d7ccf2f0bdb2c965b5a3 Mon Sep 17 00:00:00 2001
From: Quentin Glidic <sardemff7+git@sardemff7.net>
Date: Sat, 19 May 2012 14:37:05 +0200
Subject: [PATCH 7/9] Autotools: Do not include var.docs.mk

---
 addons/Makefile.am                 |    2 --
 codenav/Makefile.am                |    2 --
 debugger/Makefile.am               |    2 --
 devhelp/Makefile.am                |    2 --
 geanydoc/Makefile.am               |    2 --
 geanyextrasel/Makefile.am          |    2 --
 geanygdb/Makefile.am               |    2 --
 geanygendoc/Makefile.am            |    2 --
 geanyinsertnum/Makefile.am         |    2 --
 geanylatex/Makefile.am             |    2 --
 geanylipsum/Makefile.am            |    2 --
 geanylua/Makefile.am               |    7 +++----
 geanymacro/Makefile.am             |    2 --
 geanyminiscript/Makefile.am        |    2 --
 geanynumberedbookmarks/Makefile.am |    2 --
 geanypg/Makefile.am                |    2 --
 geanyprj/Makefile.am               |    2 --
 geanysendmail/Makefile.am          |    2 --
 geanyvc/Makefile.am                |    2 --
 geniuspaste/Makefile.am            |    2 --
 gproject/Makefile.am               |    2 --
 multiterm/Makefile.am              |    2 --
 shiftcolumn/Makefile.am            |    2 --
 spellcheck/Makefile.am             |    2 --
 tableconvert/Makefile.am           |    2 --
 treebrowser/Makefile.am            |    2 --
 updatechecker/Makefile.am          |    2 --
 webhelper/Makefile.am              |    2 --
 xmlsnippets/Makefile.am            |    2 --
 29 files changed, 3 insertions(+), 60 deletions(-)

diff --git a/addons/Makefile.am b/addons/Makefile.am
index c37ea98..5c6a543 100644
--- a/addons/Makefile.am
+++ b/addons/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_ADDONS
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/codenav/Makefile.am b/codenav/Makefile.am
index 7df49d0..aae9a8f 100644
--- a/codenav/Makefile.am
+++ b/codenav/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_CODENAV
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/debugger/Makefile.am b/debugger/Makefile.am
index f455400..aef6163 100644
--- a/debugger/Makefile.am
+++ b/debugger/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_DEBUGGER
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src img
diff --git a/devhelp/Makefile.am b/devhelp/Makefile.am
index 68d3a87..96f8aee 100644
--- a/devhelp/Makefile.am
+++ b/devhelp/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_DEVHELP
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = devhelp src data
diff --git a/geanydoc/Makefile.am b/geanydoc/Makefile.am
index a25166f..2df6fc3 100644
--- a/geanydoc/Makefile.am
+++ b/geanydoc/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYDOC
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src tests
diff --git a/geanyextrasel/Makefile.am b/geanyextrasel/Makefile.am
index 338ecaa..9f24a90 100644
--- a/geanyextrasel/Makefile.am
+++ b/geanyextrasel/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYEXTRASEL
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanygdb/Makefile.am b/geanygdb/Makefile.am
index 6a5a16e..dd6dd09 100644
--- a/geanygdb/Makefile.am
+++ b/geanygdb/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYGDB
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src tests
diff --git a/geanygendoc/Makefile.am b/geanygendoc/Makefile.am
index 25c50af..e4de74c 100644
--- a/geanygendoc/Makefile.am
+++ b/geanygendoc/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYGENDOC
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src docs data
diff --git a/geanyinsertnum/Makefile.am b/geanyinsertnum/Makefile.am
index ecdc3ce..3a21014 100644
--- a/geanyinsertnum/Makefile.am
+++ b/geanyinsertnum/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYINSERTNUM
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanylatex/Makefile.am b/geanylatex/Makefile.am
index 1114d21..34c0e2d 100644
--- a/geanylatex/Makefile.am
+++ b/geanylatex/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYLATEX
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src doc
diff --git a/geanylipsum/Makefile.am b/geanylipsum/Makefile.am
index d0d4dd7..9654227 100644
--- a/geanylipsum/Makefile.am
+++ b/geanylipsum/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYLIPSUM
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanylua/Makefile.am b/geanylua/Makefile.am
index 9743236..860fe64 100644
--- a/geanylua/Makefile.am
+++ b/geanylua/Makefile.am
@@ -1,13 +1,12 @@
 # don't install docs if disabled
 if ENABLE_GEANYLUA
+include $(top_srcdir)/build/vars.build.mk
 include $(top_srcdir)/build/vars.auxfiles.mk
+
 plugin = geanylua
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
-EXTRA_DIST = util
-include $(top_srcdir)/build/vars.build.mk
 
+EXTRA_DIST = util
 
 # don't build if disabled
 if ENABLE_GEANYLUA
diff --git a/geanymacro/Makefile.am b/geanymacro/Makefile.am
index 026a832..b8cc606 100644
--- a/geanymacro/Makefile.am
+++ b/geanymacro/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYMACRO
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanyminiscript/Makefile.am b/geanyminiscript/Makefile.am
index 4cb8a7a..88d742d 100644
--- a/geanyminiscript/Makefile.am
+++ b/geanyminiscript/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYMINISCRIPT
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanynumberedbookmarks/Makefile.am b/geanynumberedbookmarks/Makefile.am
index 09b0efd..050d0a1 100644
--- a/geanynumberedbookmarks/Makefile.am
+++ b/geanynumberedbookmarks/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYNUMBEREDBOOKMARKS
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanypg/Makefile.am b/geanypg/Makefile.am
index d154934..f82dfec 100644
--- a/geanypg/Makefile.am
+++ b/geanypg/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYPG
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanyprj/Makefile.am b/geanyprj/Makefile.am
index a44d69f..45d80bf 100644
--- a/geanyprj/Makefile.am
+++ b/geanyprj/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYPRJ
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src tests
diff --git a/geanysendmail/Makefile.am b/geanysendmail/Makefile.am
index 2da4a21..58df338 100644
--- a/geanysendmail/Makefile.am
+++ b/geanysendmail/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYSENDMAIL
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/geanyvc/Makefile.am b/geanyvc/Makefile.am
index 3c821c5..da3eda8 100644
--- a/geanyvc/Makefile.am
+++ b/geanyvc/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GEANYVC
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src tests
diff --git a/geniuspaste/Makefile.am b/geniuspaste/Makefile.am
index 18f5fb2..e65680d 100644
--- a/geniuspaste/Makefile.am
+++ b/geniuspaste/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GENIUSPASTE
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/gproject/Makefile.am b/gproject/Makefile.am
index 3782c07..380199d 100644
--- a/gproject/Makefile.am
+++ b/gproject/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_GPROJECT
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src icons
diff --git a/multiterm/Makefile.am b/multiterm/Makefile.am
index f542d01..101d6b9 100644
--- a/multiterm/Makefile.am
+++ b/multiterm/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_MULTITERM
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 AUXFILES = TODO
diff --git a/shiftcolumn/Makefile.am b/shiftcolumn/Makefile.am
index 307e148..68593d6 100644
--- a/shiftcolumn/Makefile.am
+++ b/shiftcolumn/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_SHIFTCOLUMN
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/spellcheck/Makefile.am b/spellcheck/Makefile.am
index c0be5c9..4b27b4c 100644
--- a/spellcheck/Makefile.am
+++ b/spellcheck/Makefile.am
@@ -1,8 +1,6 @@
 # if spellcheck is disabled, we should distribute its files, but not install
 if ENABLE_SPELLCHECK
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/tableconvert/Makefile.am b/tableconvert/Makefile.am
index 7bed00c..a26cdd4 100644
--- a/tableconvert/Makefile.am
+++ b/tableconvert/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_TABLECONVERT
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/treebrowser/Makefile.am b/treebrowser/Makefile.am
index 1e2bae1..deb6e38 100644
--- a/treebrowser/Makefile.am
+++ b/treebrowser/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_TREEBROWSER
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/updatechecker/Makefile.am b/updatechecker/Makefile.am
index a418f66..89c54e8 100644
--- a/updatechecker/Makefile.am
+++ b/updatechecker/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_UPDATECHECKER
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
diff --git a/webhelper/Makefile.am b/webhelper/Makefile.am
index 89e58b7..221db3e 100644
--- a/webhelper/Makefile.am
+++ b/webhelper/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_WEBHELPER
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 AUXFILES = TODO
diff --git a/xmlsnippets/Makefile.am b/xmlsnippets/Makefile.am
index 1d97880..17c737c 100644
--- a/xmlsnippets/Makefile.am
+++ b/xmlsnippets/Makefile.am
@@ -1,7 +1,5 @@
 if ENABLE_XMLSNIPPETS
 include $(top_srcdir)/build/vars.auxfiles.mk
-else
-include $(top_srcdir)/build/vars.docs.mk
 endif
 
 SUBDIRS = src
-- 
1.7.10.1